function  GuiDisplayTimerFunction (DisplayTempTimer,Timerfcn,GpibAdd,GuiHandles)

persistent intSetWaitValue dblTemp;

GetStatus(GuiHandles);
fprintf(GuiHandles.SunGpibObject,'T');
strTemp = fscanf(GuiHandles.SunGpibObject);

if isempty(intSetWaitValue) || intSetWaitValue == 0
    
    fprintf(GuiHandles.SunGpibObject,'SET?');
    strSetOrWait = fscanf(GuiHandles.SunGpibObject);
        if strfind(strSetOrWait,'SET = NONE')
            strSetOrWait = 'NONE';
        end

    set (GuiHandles.SetAndWaitLabel,'string','SET:');
    intSetWaitValue = 1;
else
    fprintf(GuiHandles.SunGpibObject,'WAIT?');
    strSetOrWait = fscanf(GuiHandles.SunGpibObject);
    if strfind(strSetOrWait,'FOREVER')
        strSetOrWait = 'FOREVER';
    end

    set (GuiHandles.SetAndWaitLabel,'string','WAIT:');
    intSetWaitValue = 0;
end

set (GuiHandles.Temp,'string',strTemp);
set (GuiHandles.SetTemp,'string',strSetOrWait);

function GetStatus(handles)

CoolEnablePosition = 6;
HeatEnablePosition = 5;
PowerOnPosition = 1;
fprintf (handles.SunGpibObject,'STATUS?');
strStatusString = fscanf (handles.SunGpibObject);

if length(strStatusString) == 21 % take into account leading space character
    CoolEnablePosition = CoolEnablePosition +1;
    HeatEnablePosition = HeatEnablePosition +1;
    PowerOnPosition = PowerOnPosition+1;
end

strCoolEnableStatus = strStatusString(CoolEnablePosition);
strHeatEnableStatus = strStatusString(HeatEnablePosition);
strPowerOnStatus = strStatusString(PowerOnPosition);
    
if strCoolEnableStatus == 'N'
    set(handles.CoolEnableButton,'value',0);
    set(handles.CoolEnableButton,'backgroundcolor','default');
else
    set(handles.CoolEnableButton,'value',1);
    set(handles.CoolEnableButton,'backgroundcolor','yellow');
end

if strHeatEnableStatus == 'N'
    set(handles.HeatEnableButton,'value',0);
    set(handles.HeatEnableButton,'backgroundcolor','default');
else
    set(handles.HeatEnableButton,'value',1);
    set(handles.HeatEnableButton,'backgroundcolor','yellow');
end
if strPowerOnStatus == 'N'
    set(handles.PowerButton,'value',0);
    set(handles.PowerButton,'backgroundcolor','default');
    set(handles.PowerButton,'string','OFF');
else
    set(handles.PowerButton,'value',1);
    set(handles.PowerButton,'backgroundcolor','red');
    set(handles.PowerButton,'string','ON');
end
